HDU 1506 Largest Rectangle in a Histogram set+二分

Largest Rectangle in a Histogram

Problem Description:

A histogram is a polygon composed of a sequence of rectangles aligned at a common base line. The rectangles have equal widths but may have different heights. For example, the figure on the left shows the histogram that consists of rectangles with the heights 2, 1, 4, 5, 1, 3, 3, measured in units where 1 is the width of the rectangles:

Usually, histograms are used to represent discrete distributions, e.g., the frequencies of characters in texts. Note that the order of the rectangles, i.e., their heights, is important. Calculate the area of the largest rectangle in a histogram that is aligned at the common base line, too. The figure on the right shows the largest aligned rectangle for the depicted histogram.

Input:

The input contains several test cases. Each test case describes a histogram and starts with an integer n, denoting the number of rectangles it is composed of. You may assume that 1 <= n <= 100000. Then follow n integers h1, ..., hn, where 0 <= hi <= 1000000000. These numbers denote the heights of the rectangles of the histogram in left-to-right order. The width of each rectangle is 1. A zero follows the input for the last test case.

Output:

For each test case output on a single line the area of the largest rectangle in the specified histogram. Remember that this rectangle must be aligned at the common base line.

Sample Input:

7 2 1 4 5 1 3 3
4 1000 1000 1000 1000
0

Sample Output:

8
4000

【题目链接】**HDU - 1506 **

【题目类型】set+二分

&题意:
给你n个数,代表矩形的高度,他们的宽都是1,要你求最大的矩形的面积。

&题解:

首先看一眼范围,1e5,则nlogn可过,那么我就想了一下二分,发现可行,思路如下:
先排序,每次都从高度最小的开始找,算出以他为最高,以(*it2 - *it1 - 1)为底的面积,这样就会有n个面积取最小就好了,那么难处理就难在求这个点旁边的最近的两个点是什么?
我是用set来做的,首先set可以set.lower_bound(),还有set.insert()的复杂度是logn,那么二分找最近的点,之后每次都把用过的点insert()一下就好了。

【时间复杂度】O(nlogn)

&代码:

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int MAXN = 100000 + 5 ;
int n, s2[MAXN];
pair<int, int > s[MAXN];
bool cmp(pair<int, int > a, pair<int, int > b) {
	return a.first == b.first ? a.second > b.second : a.first < b.first;
}
set<int> sei;
set<int>::iterator it1, it2;
ll ans;
int main() {
	while (~scanf("%d", &n), n) {
		for (int i = 0; i < n; i++)
			scanf("%d", &s[i].first), s2[i] = s[i].first, s[i].second = i;
		sort(s, s + n, cmp);
		sei.clear();
		ans = 0;
		sei.insert(-1);
		sei.insert(n);
		for (int i = 0; i < n; i++) {
			int d = s[i].second;
			it1 = sei.lower_bound(d - 1);
			it2 = sei.lower_bound(d + 1);
			if (*it1 >= d && it1 != sei.begin()) it1--;
			if (it2 == sei.end())it2--;
			ans = max(ans, (ll)(*it2 - *it1 - 1) * s2[d]);
			sei.insert(d);
		}
		printf("%lld
", ans);
	}
	return 0;
}
原文地址:https://www.cnblogs.com/s1124yy/p/5819454.html